Utilities
Collaboration diagram for Utilities:

## Modules

| Function Objects
| Memory
| Metaprogramming
| Rational Arithmetic
| Time

## Classes

struct | std::_Tuple_impl< _Idx, _Elements >
struct | std::_Tuple_impl< _Idx, _Head, _Tail... >
class | std::bitset< _Nb >
struct | std::pair< _T1, _T2 >
struct | std::piecewise_construct_t
class | std::tuple< _Elements >
class | std::tuple< _T1, _T2 >
struct | std::tuple_element< __i, tuple< _Types... > >
struct | std::tuple_size< tuple< _Elements... > >
struct | std::type_index
struct | std::uses_allocator< tuple< _Types... >, _Alloc >

## Typedefs

template<typename _Tp >
using | std::__empty_not_final = __conditional_t< __is_final(_Tp), false_type, __is_empty_non_tuple< _Tp > >

## Functions

template<typename... _Args1, typename... _Args2>
constexpr | std::pair< _T1, _T2 >::pair (piecewise_construct_t, tuple< _Args1... >, tuple< _Args2... >)
template<typename _Tp >
constexpr _Tp * | std::__addressof (_Tp &__r) noexcept
template<typename _Tp , typename _Up = _Tp>
constexpr _Tp | std::__exchange (_Tp &__obj, _Up &&__new_val)
template<size_t __i, typename _Head , typename... _Tail>
constexpr _Head & | std::__get_helper (_Tuple_impl< __i, _Head, _Tail... > &__t) noexcept
template<size_t __i, typename _Head , typename... _Tail>
constexpr const _Head & | std::__get_helper (const _Tuple_impl< __i, _Head, _Tail... > &__t) noexcept
template<size_t __i, typename... _Types>
__enable_if_t<(__i >=sizeof...(_Types))> | std::__get_helper (const tuple< _Types... > &)=delete
template<typename _Tp , typename _Up = typename __inv_unwrap<_Tp>::type>
constexpr _Up && | std::__invfwd (typename remove_reference< _Tp >::type &__t) noexcept
template<typename _Callable , typename... _Args>
constexpr __invoke_result< _Callable, _Args... >::type | std::__invoke (_Callable &&__fn, _Args &&... __args) noexcept(__is_nothrow_invocable< _Callable, _Args... >::value)
template<typename _Res , typename _MemFun , typename _Tp , typename... _Args>
constexpr _Res | std::__invoke_impl (__invoke_memfun_deref, _MemFun &&__f, _Tp &&__t, _Args &&... __args)
template<typename _Res , typename _MemFun , typename _Tp , typename... _Args>
constexpr _Res | std::__invoke_impl (__invoke_memfun_ref, _MemFun &&__f, _Tp &&__t, _Args &&... __args)
template<typename _Res , typename _MemPtr , typename _Tp >
constexpr _Res | std::__invoke_impl (__invoke_memobj_deref, _MemPtr &&__f, _Tp &&__t)
template<typename _Res , typename _MemPtr , typename _Tp >
constexpr _Res | std::__invoke_impl (__invoke_memobj_ref, _MemPtr &&__f, _Tp &&__t)
template<typename _Res , typename _Fn , typename... _Args>
constexpr _Res | std::__invoke_impl (__invoke_other, _Fn &&__f, _Args &&... __args)
template<typename _Res , typename _Callable , typename... _Args>
constexpr enable_if_t< is_invocable_r_v< _Res, _Callable, _Args... >, _Res > | std::__invoke_r (_Callable &&__fn, _Args &&... __args) noexcept(is_nothrow_invocable_r_v< _Res, _Callable, _Args... >)
template<typename _Cat , typename _Tp , typename _Up >
constexpr _Cat | std::__tuple_cmp (const _Tp &, const _Up &, index_sequence<>)
template<typename _Cat , typename _Tp , typename _Up , size_t _Idx0, size_t... _Idxs>
constexpr _Cat | std::__tuple_cmp (const _Tp &__t, const _Up &__u, index_sequence< _Idx0, _Idxs... >)
template<typename _Tp >
constexpr _Tp * | std::addressof (_Tp &__r) noexcept
template<typename _Tp >
const _Tp * | std::addressof (const _Tp &&)=delete
template<typename _Tp >
auto | std::declval () noexcept -> decltype(__declval< _Tp >(0))
template<typename _Tp >
constexpr _Tp && | std::forward (typename std::remove_reference< _Tp >::type &&__t) noexcept
template<typename _Tp >
constexpr _Tp && | std::forward (typename std::remove_reference< _Tp >::type &__t) noexcept
template<typename... _Elements>
constexpr tuple< _Elements &&... > | std::forward_as_tuple (_Elements &&... __args) noexcept
template<size_t __i, typename... _Elements>
constexpr const __tuple_element_t< __i, tuple< _Elements... > > && | std::get (const tuple< _Elements... > &&__t) noexcept
template<size_t __i, typename... _Elements>
constexpr const __tuple_element_t< __i, tuple< _Elements... > > & | std::get (const tuple< _Elements... > &__t) noexcept
template<size_t __i, typename... _Elements>
constexpr __tuple_element_t< __i, tuple< _Elements... > > && | std::get (tuple< _Elements... > &&__t) noexcept
template<size_t __i, typename... _Elements>
constexpr __tuple_element_t< __i, tuple< _Elements... > > & | std::get (tuple< _Elements... > &__t) noexcept
template<typename _T1 , typename _T2 >
constexpr pair< typename __decay_and_strip< _T1 >::__type, typename __decay_and_strip< _T2 >::__type > | make_pair (_T1 &&__x, _T2 &&__y)
template<typename... _Elements>
constexpr tuple< typename __decay_and_strip< _Elements >::__type... > | std::make_tuple (_Elements &&... __args)
template<typename _Tp >
constexpr std::remove_reference< _Tp >::type && | std::move (_Tp &&__t) noexcept
template<typename _Tp >
constexpr __conditional_t< __move_if_noexcept_cond< _Tp >::value, const _Tp &, _Tp && > | std::move_if_noexcept (_Tp &__x) noexcept
template<typename... _Tps, typename... _Ups>
constexpr common_comparison_category_t< __detail::__synth3way_t< _Tps, _Ups >... > | std::operator<=> (const tuple< _Tps... > &__t, const tuple< _Ups... > &__u)
template<typename... _TElements, typename... _UElements>
constexpr bool | std::operator== (const tuple< _TElements... > &__t, const tuple< _UElements... > &__u)
template<typename _Tp >
constexpr enable_if< __and_< __not_< __is_tuple_like< _Tp > >, is_move_constructible< _Tp >, is_move_assignable< _Tp > >::value >::type | std::swap (_Tp &__a, _Tp &__b) noexcept(/*conditional */) is_nothrow_move_assignable< _Tp > >
template<typename _Tp , size_t _Nm>
constexpr enable_if< __is_swappable< _Tp >::value >::type | std::swap (_Tp(&__a)[_Nm], _Tp(&__b)[_Nm]) noexcept(/*conditional */)
template<typename... _Elements>
constexpr enable_if< __and_< __is_swappable< _Elements >... >::value >::type | std::swap (tuple< _Elements... > &__x, tuple< _Elements... > &__y) noexcept(noexcept(__x.swap(__y)))
template<typename... _Elements>
constexpr tuple< _Elements &... > | std::tie (_Elements &... __args) noexcept
template<typename... _UTypes>
| std::tuple (_UTypes...) -> tuple< _UTypes... >
template<typename _Alloc , typename... _UTypes>
| std::tuple (allocator_arg_t, _Alloc, _UTypes...) -> tuple< _UTypes... >
template<typename _Alloc , typename _T1 , typename _T2 >
| std::tuple (allocator_arg_t, _Alloc, pair< _T1, _T2 >) -> tuple< _T1, _T2 >
template<typename _Alloc , typename... _UTypes>
| std::tuple (allocator_arg_t, _Alloc, tuple< _UTypes... >) -> tuple< _UTypes... >
template<typename _T1 , typename _T2 >
| std::tuple (pair< _T1, _T2 >) -> tuple< _T1, _T2 >
template<typename... _Tpls, typename = typename enable_if<__and_<__is_tuple_like<_Tpls>...>::value>::type>
constexpr auto | std::tuple_cat (_Tpls &&... __tpls) -> typename __tuple_cat_result< _Tpls... >::__type

## Variables

constexpr _Swallow_assign | std::ignore
constexpr piecewise_construct_t | std::piecewise_construct
template<typename... _Types>
constexpr size_t | std::tuple_size_v< const tuple< _Types... > >
template<typename... _Types>
constexpr size_t | std::tuple_size_v< tuple< _Types... > >
template<typename _T1 , typename _T2 >
| pair (_T1, _T2) -> pair< _T1, _T2 >
template<typename _T1 , typename _T2 >
constexpr bool | operator== (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr bool | operator< (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr bool | operator!= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr bool | operator> (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr bool | operator<= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr bool | operator>= (const pair< _T1, _T2 > &__x, const pair< _T1, _T2 > &__y)
template<typename _T1 , typename _T2 >
constexpr enable_if< __and_< __is_swappable< _T1 >, __is_swappable< _T2 > >::value >::type | swap (pair< _T1, _T2 > &__x, pair< _T1, _T2 > &__y) noexcept(noexcept(__x.swap(__y)))

## Detailed Description

Basic function and class templates used with the rest of the library. Includes pair, swap, forward/move helpers, declval, integer_sequence.

## Typedef Documentation

## __empty_not_final

template<typename _Tp >

using std::__empty_not_final = typedef __conditional_t<__is_final(_Tp), false_type, __is_empty_non_tuple<_Tp> >

Definition at line 77 of file tuple.

## Function Documentation

## pair() [1/2]

template<typename _T1 , typename _T2 >

pair | ( | _T1 | ,
|  | _T2 |
| ) |  | -> pair< _T1, _T2 >

related

Two pairs of the same type are equal iff their members are equal.

## pair() [2/2]

template<class _T1 , class _T2 >
template<typename... _Args1, typename... _Args2>

constexpr std::pair< _T1, _T2 >::pair | ( | piecewise_construct_t | ,
|  | tuple< _Args1... > | __first,
|  | tuple< _Args2... > | __second
| ) |  |

inline constexpr

"piecewise construction" using a tuple of arguments for each member.

Parameters

  __first | Arguments for the first member of the pair.
  __second | Arguments for the second member of the pair.

The elements of each tuple will be used as the constructor arguments for the data members of the pair.

Definition at line 2872 of file tuple.

## __addressof()

template<typename _Tp >

constexpr _Tp * std::__addressof | ( | _Tp & | __r | ) |

inline constexpr noexcept

Same as C++11 std::addressof.

Definition at line 51 of file move.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), std::addressof(), std::basic_ios< _CharT, _Traits >::copyfmt(), std::forward_list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::merge(), std::list< _Tp, _Alloc >::merge(), std::sub_match< _BiIter >::operator(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence, _Category >::operator=(), __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::operator=(), std::deque< _Tp, _Alloc >::operator=(), std::forward_list< _Tp, _Alloc >::operator=(), std::list< _Tp, _Alloc >::operator=(), std::sub_match< _BiIter >::operator==(), std::list< _Tp, _Alloc >::splice(), and std::list< _Tp, _Alloc >::splice().

## __exchange()

template<typename _Tp , typename _Up = _Tp>

constexpr _Tp std::__exchange | ( | _Tp & | __obj,
|  | _Up && | __new_val
| ) |  |

inline constexpr

Definition at line 174 of file move.h.

## __get_helper() [1/2]

template<size_t __i, typename _Head , typename... _Tail>

constexpr _Head & std::__get_helper | ( | _Tuple_impl< __i, _Head, _Tail... > & | __t | ) |

constexpr noexcept

Definition at line 2427 of file tuple.

## __get_helper() [2/2]

template<size_t __i, typename _Head , typename... _Tail>

constexpr const _Head & std::__get_helper | ( | const _Tuple_impl< __i, _Head, _Tail... > & | __t | ) |

constexpr noexcept

Definition at line 2432 of file tuple.

## __invfwd()

template<typename _Tp , typename _Up = typename __inv_unwrap<_Tp>::type>

constexpr _Up && std::__invfwd | ( | typename remove_reference< _Tp >::type & | __t | ) |

constexpr noexcept

Definition at line 55 of file invoke.h.

## __invoke()

template<typename _Callable , typename... _Args>

constexpr __invoke_result< _Callable, _Args... >::type std::__invoke | ( | _Callable && | __fn,
|  | _Args &&... | __args
| ) |  |

constexpr noexcept

Invoke a callable object.

Definition at line 90 of file invoke.h.

## __invoke_impl() [1/5]

template<typename _Res , typename _MemFun , typename _Tp , typename... _Args>

constexpr _Res std::__invoke_impl | ( | __invoke_memfun_deref | ,
|  | _MemFun && | __f,
|  | _Tp && | __t,
|  | _Args &&... | __args
| ) |  |

constexpr

Definition at line 71 of file invoke.h.

## __invoke_impl() [2/5]

template<typename _Res , typename _MemFun , typename _Tp , typename... _Args>

constexpr _Res std::__invoke_impl | ( | __invoke_memfun_ref | ,
|  | _MemFun && | __f,
|  | _Tp && | __t,
|  | _Args &&... | __args
| ) |  |

constexpr

Definition at line 65 of file invoke.h.

## __invoke_impl() [3/5]

template<typename _Res , typename _MemPtr , typename _Tp >

constexpr _Res std::__invoke_impl | ( | __invoke_memobj_deref | ,
|  | _MemPtr && | __f,
|  | _Tp && | __t
| ) |  |

constexpr

Definition at line 84 of file invoke.h.

## __invoke_impl() [4/5]

template<typename _Res , typename _MemPtr , typename _Tp >

constexpr _Res std::__invoke_impl | ( | __invoke_memobj_ref | ,
|  | _MemPtr && | __f,
|  | _Tp && | __t
| ) |  |

constexpr

Definition at line 79 of file invoke.h.

## __invoke_impl() [5/5]

template<typename _Res , typename _Fn , typename... _Args>

constexpr _Res std::__invoke_impl | ( | __invoke_other | ,
|  | _Fn && | __f,
|  | _Args &&... | __args
| ) |  |

constexpr

Definition at line 60 of file invoke.h.

## __invoke_r()

template<typename _Res , typename _Callable , typename... _Args>

constexpr enable_if_t< is_invocable_r_v< _Res, _Callable, _Args... >, _Res > std::__invoke_r | ( | _Callable && | __fn,
|  | _Args &&... | __args
| ) |  |

constexpr noexcept

Definition at line 104 of file invoke.h.

## __tuple_cmp() [1/2]

template<typename _Cat , typename _Tp , typename _Up >

constexpr _Cat std::__tuple_cmp | ( | const _Tp & | ,
|  | const _Up & | ,
|  | index_sequence<> |
| ) |  |

constexpr

Definition at line 2570 of file tuple.

## __tuple_cmp() [2/2]

template<typename _Cat , typename _Tp , typename _Up , size_t _Idx0, size_t... _Idxs>

constexpr _Cat std::__tuple_cmp | ( | const _Tp & | __t,
|  | const _Up & | __u,
|  | index_sequence< _Idx0, _Idxs... > |
| ) |  |

constexpr

Definition at line 2576 of file tuple.

## addressof()

template<typename _Tp >

constexpr _Tp * std::addressof | ( | _Tp & | __r | ) |

inline constexpr noexcept

Returns the actual address of the object or function referenced by r, even in the presence of an overloaded operator&.

Parameters

  __r | Reference to an object or function.

Returns
  The actual address.

Definition at line 162 of file move.h.

References std::__addressof().

## declval()

template<typename _Tp >

auto std::declval | ( |  | ) | -> decltype(__declval< _Tp >(0))

noexcept

Utility to simplify expressions used in unevaluated operands

Since
  C++11

Definition at line 2470 of file type_traits.

## forward() [1/2]

template<typename _Tp >

constexpr _Tp && std::forward | ( | typename std::remove_reference< _Tp >::type && | __t | ) |

constexpr noexcept

Forward an rvalue.

Returns
  The parameter cast to the specified type.

This function is used to implement "perfect forwarding".

Definition at line 82 of file move.h.

## forward() [2/2]

template<typename _Tp >

constexpr _Tp && std::forward | ( | typename std::remove_reference< _Tp >::type & | __t | ) |

constexpr noexcept

Forward an lvalue.

Returns
  The parameter cast to the specified type.

This function is used to implement "perfect forwarding".

Definition at line 70 of file move.h.

## forward_as_tuple()

template<typename... _Elements>

constexpr tuple< _Elements &&... > std::forward_as_tuple | ( | _Elements &&... | __args | ) |

constexpr noexcept

Create a tuple of lvalue or rvalue references to the arguments.

Definition at line 2650 of file tuple.

Referenced by std::map< _Key, _Tp, _Compare, _Alloc >::insert_or_assign(), std::map< _Key, _Tp, _Compare, _Alloc >::insert_or_assign(), std::map< _Key, _Tp, _Compare, _Alloc >::try_emplace(), and std::map< _Key, _Tp, _Compare, _Alloc >::try_emplace().

## get() [1/4]

template<size_t __i, typename... _Elements>

constexpr const __tuple_element_t< __i, tuple< _Elements... > > && std::get | ( | const tuple< _Elements... > && | __t | ) |

constexpr noexcept

Return a const rvalue reference to the ith element of a const tuple rvalue.

Definition at line 2464 of file tuple.

## get() [2/4]

template<size_t __i, typename... _Elements>

constexpr const __tuple_element_t< __i, tuple< _Elements... > > & std::get | ( | const tuple< _Elements... > & | __t | ) |

constexpr noexcept

Return a const reference to the ith element of a const tuple.

Definition at line 2449 of file tuple.

## get() [3/4]

template<size_t __i, typename... _Elements>

constexpr __tuple_element_t< __i, tuple< _Elements... > > && std::get | ( | tuple< _Elements... > && | __t | ) |

constexpr noexcept

Return an rvalue reference to the ith element of a tuple rvalue.

Definition at line 2455 of file tuple.

## get() [4/4]

template<size_t __i, typename... _Elements>

constexpr __tuple_element_t< __i, tuple< _Elements... > > & std::get | ( | tuple< _Elements... > & | __t | ) |

constexpr noexcept

Return a reference to the ith element of a tuple.

Definition at line 2443 of file tuple.

## make_pair()

template<typename _T1 , typename _T2 >

constexpr pair< typename __decay_and_strip< _T1 >::__type, typename __decay_and_strip< _T2 >::__type > make_pair | ( | _T1 && | __x,
|  | _T2 && | __y
| ) |  |

related

A convenience wrapper for creating a pair from two objects.

Parameters

  __x | The first object.
  __y | The second object.

Returns
  A newly-constructed pair<> object of the appropriate type.

The C++98 standard says the objects are passed by reference-to-const, but C++03 says they are passed by value (this was LWG issue #181).

Since C++11 they have been passed by forwarding reference and then forwarded to the new members of the pair. To create a pair with a member of reference type, pass a `reference_wrapper` to this function.

Definition at line 1132 of file stl_pair.h.

## make_tuple()

template<typename... _Elements>

constexpr tuple< typename __decay_and_strip< _Elements >::__type... > std::make_tuple | ( | _Elements &&... | __args | ) |

constexpr

Create a tuple containing copies of the arguments.

Definition at line 2638 of file tuple.

## move()

template<typename _Tp >

constexpr std::remove_reference< _Tp >::type && std::move | ( | _Tp && | __t | ) |

constexpr noexcept

Convert a value to an rvalue.

Parameters

  __t | A thing of arbitrary type.

Returns
  The parameter cast to an rvalue-reference to allow moving it.

Definition at line 126 of file move.h.

Referenced by std::unique_ptr< _Tp, _Dp >::~unique_ptr(), std::basic_regex< _Ch_type, _Rx_traits >::assign(), std::atomic_compare_exchange_strong(), std::atomic_compare_exchange_strong(), std::atomic_compare_exchange_strong_explicit(), std::atomic_compare_exchange_strong_explicit(), std::atomic_compare_exchange_weak(), std::atomic_compare_exchange_weak(), std::atomic_compare_exchange_weak_explicit(), std::atomic_compare_exchange_weak_explicit(), std::atomic_exchange(), std::atomic_exchange(), std::atomic_store(), std::atomic_store(), std::shared_ptr< _Tp >::const_pointer_cast(), std::shared_ptr< _Tp >::dynamic_pointer_cast(), std::for_each_n(), std::get(), std::get(), std::get(), std::get(), std::get(), std::get(), std::map< _Key, _Tp, _Compare, _Alloc >::insert(), std::multimap< _Key, _Tp, _Compare, _Alloc >::insert(), std::multiset< _Key, _Compare, _Alloc >::insert(), std::set< _Key, _Compare, _Alloc >::insert(), std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert(), std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert(), std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert(), std::vector< _Tp, _Alloc >::insert(), std::deque< _Tp, _Alloc >::insert(), std::list< _Tp, _Alloc >::insert(), std::map< _Key, _Tp, _Compare, _Alloc >::insert(), std::multimap< _Key, _Tp, _Compare, _Alloc >::insert(), std::vector< _Tp, _Alloc >::insert(), std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert(), std::map< _Key, _Tp, _Compare, _Alloc >::insert(), std::multimap< _Key, _Tp, _Compare, _Alloc >::insert(), std::multiset< _Key, _Compare, _Alloc >::insert(), std::set< _Key, _Compare, _Alloc >::insert(), std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert(), std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert(), std::map< _Key, _Tp, _Compare, _Alloc >::insert(), std::multimap< _Key, _Tp, _Compare, _Alloc >::insert(), std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_multimap< _Key, _Tp, _Hash, _Pred, _Alloc >::insert(), std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert(), std::unordered_multiset< _Value, _Hash, _Pred, _Alloc >::insert(), std::forward_list< _Tp, _Alloc >::merge(), std::forward_list< _Tp, _Alloc >::merge(), std::move_if_noexcept(), std::chrono::operator<<(), std::deque< _Tp, _Alloc >::operator=(), std::forward_list< _Tp, _Alloc >::operator=(), std::function< _Res(_ArgTypes...)>::operator=(), std::list< _Tp, _Alloc >::operator=(), std::vector< _Tp, _Alloc >::operator=(), std::unordered_map< _Key, _Tp, _Hash, _Pred, _Alloc >::operator[](), std::shared_ptr< _Tp >::reinterpret_pointer_cast(), std::unique_ptr< _Tp[], _Dp >::reset(), std::unique_ptr< _Tp, _Dp >::reset(), std::list< _Tp, _Alloc >::splice(), std::list< _Tp, _Alloc >::splice(), and std::shared_ptr< _Tp >::static_pointer_cast().

## move_if_noexcept()

template<typename _Tp >

constexpr __conditional_t< __move_if_noexcept_cond< _Tp >::value, const _Tp &, _Tp && > std::move_if_noexcept | ( | _Tp & | __x | ) |

constexpr noexcept

Conditionally convert a value to an rvalue.

Parameters

  __x | A thing of arbitrary type.

Returns
  The parameter, possibly cast to an rvalue-reference.

Same as std::move unless the type's move constructor could throw and the type is copyable, in which case an lvalue-reference is returned instead.

Definition at line 147 of file move.h.

References std::move().

## operator!=()

template<typename _T1 , typename _T2 >

constexpr bool operator!= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Uses `operator==` to find the result.

Definition at line 1052 of file stl_pair.h.

## operator<()

template<typename _T1 , typename _T2 >

constexpr bool operator< | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Defines a lexicographical order for pairs.

For two pairs of the same type, `P` is ordered before `Q` if `P.first` is less than `Q.first`, or if `P.first` and `Q.first` are equivalent (neither is less than the other) and `P.second` is less than `Q.second`.

Definition at line 1044 of file stl_pair.h.

## operator<=()

template<typename _T1 , typename _T2 >

constexpr bool operator<= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Uses `operator<` to find the result.

Definition at line 1063 of file stl_pair.h.

## operator<=>()

template<typename... _Tps, typename... _Ups>

constexpr common_comparison_category_t< __detail::__synth3way_t< _Tps, _Ups >... > std::operator<=> | ( | const tuple< _Tps... > & | __t,
|  | const tuple< _Ups... > & | __u
| ) |  |

constexpr

Definition at line 2587 of file tuple.

## operator==() [1/2]

template<typename _T1 , typename _T2 >

constexpr bool operator== | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Two pairs of the same type are equal iff their members are equal.

Definition at line 1033 of file stl_pair.h.

## operator==() [2/2]

template<typename... _TElements, typename... _UElements>

constexpr bool std::operator== | ( | const tuple< _TElements... > & | __t,
|  | const tuple< _UElements... > & | __u
| ) |  |

constexpr

Definition at line 2556 of file tuple.

## operator>()

template<typename _T1 , typename _T2 >

constexpr bool operator> | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Uses `operator<` to find the result.

Definition at line 1058 of file stl_pair.h.

## operator>=()

template<typename _T1 , typename _T2 >

constexpr bool operator>= | ( | const pair< _T1, _T2 > & | __x,
|  | const pair< _T1, _T2 > & | __y
| ) |  |

related

Uses `operator<` to find the result.

Definition at line 1070 of file stl_pair.h.

## swap() [1/4]

template<typename _Tp >

constexpr enable_if< __and_< __not_< __is_tuple_like< _Tp > >, is_move_constructible< _Tp >, is_move_assignable< _Tp > >::value >::type std::swap | ( | _Tp & | __a,
|  | _Tp & | __b
| ) |  |

inline constexpr noexcept

Swaps two values.

Parameters

  __a | A thing of arbitrary type.
  __b | Another thing of arbitrary type.

Returns
  Nothing.

Definition at line 213 of file move.h.

## swap() [2/4]

template<typename _Tp , size_t _Nm>

constexpr enable_if< __is_swappable< _Tp >::value >::type std::swap | ( | _Tp(&) | __a[_Nm],
|  | _Tp(&) | __b[_Nm]
| ) |  |

inline constexpr noexcept

Swap the contents of two arrays.

Definition at line 237 of file move.h.

## swap() [3/4]

template<typename _T1 , typename _T2 >

constexpr enable_if< __and_< __is_swappable< _T1 >, __is_swappable< _T2 > >::value >::type swap | ( | pair< _T1, _T2 > & | __x,
|  | pair< _T1, _T2 > & | __y
| ) |  |

related

Swap overload for pairs. Calls std::pair::swap().

Note
  This std::swap overload is not declared in C++03 mode, which has performance implications, e.g. see https://gcc.gnu.org/PR38466

Definition at line 1089 of file stl_pair.h.

## swap() [4/4]

template<typename... _Elements>

constexpr enable_if< __and_< __is_swappable< _Elements >... >::value >::type std::swap | ( | tuple< _Elements... > & | __x,
|  | tuple< _Elements... > & | __y
| ) |  |

inline constexpr delete noexcept

Exchange the values of two tuples.

Exchange the values of two const tuples (if const elements can be swapped)

Definition at line 2803 of file tuple.

## tie()

template<typename... _Elements>

constexpr tuple< _Elements &... > std::tie | ( | _Elements &... | __args | ) |

constexpr noexcept

Return a tuple of lvalue references bound to the arguments.

Definition at line 2789 of file tuple.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt().

## tuple_cat()

template<typename... _Tpls, typename = typename enable_if<__and_<__is_tuple_like<_Tpls>...>::value>::type>

constexpr auto std::tuple_cat | ( | _Tpls &&... | __tpls | ) | -> typename __tuple_cat_result<_Tpls...>::__type

constexpr

Create a `tuple` containing all elements from multiple tuple-like objects.

Definition at line 2775 of file tuple.

## Variable Documentation

## ignore

constexpr _Swallow_assign std::ignore

inline constexpr

Used with `std::tie` to ignore an element of a tuple

When using `std::tie` to assign the elements of a tuple to variables, unwanted elements can be ignored by using `std::ignore`. For example:

int x, y;
std::tie(x, std::ignore, y) = std::make_tuple(1, 2, 3);
std::make_tuple
constexpr tuple< typename __decay_and_strip< _Elements >::__type... > make_tuple(_Elements &&... __args)
Create a tuple containing copies of the arguments.
Definition tuple:2638
std::ignore
constexpr _Swallow_assign ignore
Definition tuple:2853
std::tie
constexpr tuple< _Elements &... > tie(_Elements &... __args) noexcept
Return a tuple of lvalue references bound to the arguments.
Definition tuple:2789
std::auto_ptr_ref
Definition auto_ptr.h:49

This assignment will perform `x=1; std::ignore=2; y=3;` which results in the second element being ignored.

Since
  C++11

Definition at line 2853 of file tuple.

## piecewise_construct

constexpr piecewise_construct_t std::piecewise_construct

inline constexpr

Tag for piecewise construction of std::pair objects.

Definition at line 82 of file stl_pair.h.

Referenced by std::map< _Key, _Tp, _Compare, _Alloc >::insert_or_assign(), std::map< _Key, _Tp, _Compare, _Alloc >::insert_or_assign(), std::map< _Key, _Tp, _Compare, _Alloc >::operator[](), std::map< _Key, _Tp, _Compare, _Alloc >::try_emplace(), and std::map< _Key, _Tp, _Compare, _Alloc >::try_emplace().

## tuple_size_v< const tuple< _Types... > >

template<typename... _Types>

constexpr size_t std::tuple_size_v< const tuple< _Types... > >

inline constexpr

Definition at line 2412 of file tuple.

## tuple_size_v< tuple< _Types... > >

template<typename... _Types>

constexpr size_t std::tuple_size_v< tuple< _Types... > >

inline constexpr

Definition at line 2408 of file tuple.